import win32.windows;
import win32frame.writek;
import win32frame.MainWindow;

class Win32Frame {
  MainWindow mainwindow ;
  MSG        msg;
  HWND       hmain;
  BOOL       bRet;
  HACCEL     hAccel;
  HINSTANCE  hInstance ;
  int        _winX,_winY,_winW,_winH ;
  int        style ;

  this(){
    _winX=CW_USEDEFAULT ;
    _winY=CW_USEDEFAULT ;
    _winW=CW_USEDEFAULT ;
    _winH=CW_USEDEFAULT ;
    style  =0 ;
  }

  @property int winX(){ return(_winX) ; }
  @property int winY(){ return(_winY) ; }
  @property int winW(){ return(_winW) ; }
  @property int winH(){ return(_winH) ; }

  int setMainWindow(MainWindow mainwin){
    mainwindow = mainwin ;
    return(0) ;
  }

  int setWindowPosition(int x, int y, int w, int h){
    _winX=x ;
    _winY=y ;
    _winW=w ;
    _winH=h ;
    return(0) ;
  }

  int setWindowStyle(int style){
    this.style=style ;
    return(0) ;
  }

  int start(){
    int ret ;
    hInstance = GetModuleHandle(null);
    ret=mainwindow.create( style, winX, winY, winW, winH, null,null) ;
    if( ret<0 ){
      writek("MainWindow open error.\n") ;
      return(-1) ;
    }
    hmain=mainwindow.getHWND() ;
    hAccel = LoadAccelerators(hInstance, cast(wchar*)("MYACCEL"));
    while( (bRet = GetMessage(&msg , null , 0 , 0)) != 0 ){
      if (bRet == -1) {
        break;
      } else {
        if (!TranslateAccelerator(hmain, hAccel, &msg)) {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
        }
      }
    }
    return(0) ;
  }
}
